defmodule Dp.Bev do

  @moduledoc """
  Bevezetés a DP-be

  @author "hanak@emt.bme.hu"
  @date   "$LastChangedDate: 2021-09-23 07:45:58 +0200 (cs, 23 szept 2021) $$"
  """

  # A fájl nevét csupa kisbetűvel kell írni, szóköz helyett aláhúzás-jellel (snake case)
  # A modul nevét egybe kell írni, a szavakat nagybetűvel kell kezdeni (camel case)

  @spec fac(n::integer) :: f::integer
  # f = n! (azaz f az n faktoriálisa)
  def fac(0), do: 1            # ha az n=0 mintaillesztés sikeres
  def fac(n), do: n * fac(n-1) # ha az n=0 mintaillesztés sikertelen

  @spec sum(xs::[integer]) :: s::integer
  # Az xs számlista összege s
  def sum([]), do: 0
  def sum(xs)  do x = hd(xs); rs = tl(xs); x + sum rs end

  @spec append(xs::[any], ys::[any]) :: rs::[any]
  # rs az xs lista ys elé fűzésével kapott lista
  def append([], ys), do: ys
  def append(xs, ys), do: [(hd xs) | (append (tl xs), ys)]

  @spec revapp(xs::[any], ys::[any]) :: rs::[any]
  # rs a megfordított xs lista ys elé fűzésével kapott lista
  def revapp([], ys), do: ys
  def revapp(xs, ys), do: revapp (tl xs), [(hd xs) | ys]
    
end
